/*
 * common.h : difinitions used system-wide
 *   by uratan! 2008.9.4
 */
#ifndef __COMMON_H__
#define __COMMON_H__

#define NULL    ((void *)0)

#define TRUE    1
#define FALSE   0

#define DONE    0
#define YET     1

typedef unsigned char  BYTE;
typedef unsigned short WORD;
typedef unsigned long  DWORD;
typedef unsigned int   BOOL;

typedef signed char    s_char;
typedef unsigned char  u_char;
typedef unsigned short u_short;
typedef unsigned long  u_long;

typedef void (*INTR_subFUNCs)(u_long x);

/* ===============================================================
 * System configuration: Fosc, Fcclk, Fcco, Fpclk must be defined
 */
/*
 * Crystal frequence, 10MHz~25MHz should be the same as actual status.
 */
#define Fosc	12000000

/*
 * System frequence, should be (1~32)multiples of Fosc,
 * and should be equal or less than 60MHz.
 */
#define Fcclk	(Fosc * 5)		/* 60MHz */

/*
 * CCO frequence, should be 2/4/8/16 multiples of Fcclk,
 * ranged from 156MHz to 320MHz.
 */
#define Fcco	(Fcclk * 4)		/* 240MHz */

/*
 * VPB clock frequence, must be 1/2/4 multiples of (Fcclk / 4).
 */
//#define Fpclk	(1 * (Fcclk / 4))		/* 15MHz */
#define Fpclk	(2 * (Fcclk / 4))		/* 30MHz */
	/*
	 * with reading endpoint buffer, 'byte-lost' occured when VPB is 15MHz
	 *   (VPB=30MHz,60MHz is OK)
	 */

/*
 * use P0.4 for monitor LED
 */
#define LED_MON     (1<<4)
#define MON_LED_OFF    FIO0SET = LED_MON
#define MON_LED_ON     FIO0CLR = LED_MON

/*
 * use STAT LED(green) for misc monitor
 */
#define LED_STAT    (1<<24)

/*
 * use P1.25, P1.26 for debug
 */
#define DEBUG_PORT   (1<<25)
#define DEBUG_PORT2  (1<<26)

/*
 * shared functions
 */
/* in common.c */
extern void cm_init_serial0(u_long baudrate);
extern void cm_putchar(int ch);
extern int cm_keyin(void);
extern u_char cm_getchar(void);
/* in rprintf.c */
extern void rprintf ( char const *format, ... );


#endif  /* __COMMON_H__ */
